#include "MechSolver.h"
void MechSolver::DISPLAY()
{
	subplot(2, 1, 1);
	axis(0.0, 1.2*m_l, 0, m_h+0.1*m_h);
	plot(m_x_1, m_y_1); set("r"); //set("+");
	plot(m_x_2, m_y_2); set("g"); //set("d");
	plot(m_x_e, m_y_e); set("b"); set("o");
	subplot(2, 1, 2);
	axis(0.0, m_l, -m_teta_0-10, m_teta_0+10);
	plot(m_x_2, m_teta);
};
void MechSolver::calculate_analytical_values() 
{
	m_v0y = m_v0*sin(m_teta_0 *  M_PI/180);
	m_v0x = m_v0*cos(m_teta_0 *  M_PI/180);
	m_t_max = m_v0y / g;
	m_t_full = 2 * m_t_max;
	m_h = m_v0y*m_v0y / 2 / g;
	m_l = m_v0*m_v0*sin(2 * m_teta_0 *  M_PI / 180)/g;//aklda /g-ze
	if (m_dt==0)
	{
		m_dt = m_t_full / 100;
	}
	
	m_finished = false;
	m_pause = false;
};

void MechSolver::calc_Y_X(int n)
{
	m_x_1 = linspace(0.0, m_l, n);
	m_y_1.resize(m_x_1.size());
	const double tgteta_0 = tan(m_teta_0 *  M_PI / 180);
	const double meore_cevri = g / 2 / m_v0x / m_v0x; //pdf-is 9 formulashi meore cevri/koeficienti
	for (int i=0;i<m_x_1.size();i++)
	{
		m_y_1[i] = m_x_1[i] * tgteta_0 - meore_cevri*m_x_1[i] * m_x_1[i];
	}
};

void MechSolver::calc_analytical_t(double t)
{
	 const double a_x = 0.0;
	 const double a_y = -g;
	 const double v_x = m_v0x;
	 double v_y = m_v0y - g*t;
	 double x = m_v0x*t;
	 double y = m_v0y*t - g*t*t / 2;
	 double teta = atan(v_y/v_x)*180/M_PI;
	 m_x_2.push_back(x);
	 m_y_2.push_back(y);
	 m_teta.push_back(teta);
};
void MechSolver::init_euler()
{
	m_vx_e = m_v0x;
	m_vy_e = m_v0y;
	m_x_e.push_back(0.0);
	m_y_e.push_back(0.0);
	m_step = 0;
	m_t = 0;
	m_x_e_val = 0.0;
	m_y_e_val = 0.0;
	m_pause = false;

}
void MechSolver::calc_euler_t() {
	if (m_finished) return;
	
	m_step += 1;
	m_t = m_dt*m_step;
	m_x_e_val = m_x_e_val + m_vx_e*m_dt;
	m_y_e_val = m_y_e_val + m_vy_e*m_dt;
	if (m_y_e_val<0)
	{
		m_y_e_val = 0;
		m_finished = true;
		return;
	}
	m_vx_e = m_vx_e;
	m_vy_e = m_vy_e - g*m_dt;
	m_x_e.push_back(m_x_e_val);
	m_y_e.push_back(m_y_e_val);

};
void MechSolver::calc_analytical()
{
	double dt = m_t_full / 256;
	for (size_t i = 0; i < 256; i++)
	{
		calc_analytical_t(i*dt);//m_dt ki ara dt

	}
}
