#ifndef __MECHSOLVER_H
#define  __MECHSOLVER_H
#include "matplotpp.h"
#define M_PI 3.14159265358979323846 
const double g = 9.8;
class MechSolver : public MatPlot
{
public:
	dvec m_x_1, m_y_1;
	dvec m_x_2, m_y_2;
	dvec m_x_e, m_y_e;
	double m_vx_1, m_vy_1;
	double m_vx_e, m_vy_e;
	dvec m_teta;
	double m_v0, m_teta_0;
	double m_v0x, m_v0y;
	double m_a_y;
	double m_t_max;
	double m_t_full;
	double m_h;
	double m_l;
	double m_t;
	double m_dt;
	int m_step;
	double m_x_e_val, m_y_e_val;
	bool m_finished;
	bool m_pause;
public:
	virtual void DISPLAY();
	void calculate_analytical_values();
	void calc_Y_X(int N);
	void calc_analytical_t(double t);
	void init_euler();
	void calc_euler_t();
	void calc_analytical();
	
	
};
#endif // !1